<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\LaporanpelumasModel;
use App\Http\Services\LaporanpelumasdetailsService;
use App\Http\Base\BaseService;
use App\Http\Models\LaporanpelumasitemdetailsModel;
use App\Http\Models\SystemparameterModel;
use App\Http\Models\ItemModel;

class LaporanpelumasService extends BaseService
{
	/**
     PelumasService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new LaporanpelumasModel();
		$this->detailService = new LaporanpelumasdetailsService();
	}

	public function index()
	{
		return $this->model->getQuery()->get();
	}

	public function pagingBulan($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->getQuery()
			->where("laporanpelumas.kapalId", "=", $auth->kapalId)
			->where("laporanpelumas.tipe", "=", "MONTH");

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("laporanpelumas.tahun", "desc")->orderBy("laporanpelumas.bulan", "desc");
		}

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	public function pagingVoyage($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->getQuery()
			->where("laporanpelumas.kapalId", "=", $auth->kapalId)
			->where("laporanpelumas.tipe", "=", "VOYAGE");

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("laporanpelumas.voyage_to", "desc")->orderBy("laporanpelumas.voyage_from", "desc");
		}

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return LaporanpelumasModel
	 */
	public function show($request, $id)
	{
		$auth = json_decode($request->session()->get('auth'));

		$model = $this->model->getQuery()
			->where("laporanpelumas.kapalId", "=", $auth->kapalId)
			->where("laporanpelumas.id", "=", $id)->first();

		if ($model) {
			if ($model->tipe == "VOYAGE") {
				$model->details = $this->detailService->showByVoyageVer2($model->id);
			} else if ($model->tipe == "MONTH") {
				$model->details = $this->detailService->showByMonth($model->id);
			} else {
				$model = null;
			}
		}
		return $model;
	}

	public function getLatestDataReport()
	{
		return $this->model->getQuery()
			->where("laporanpelumas.tipe", "=", "VOYAGE")
			->orderBy("laporanpelumas.voyage_to", "desc")
			->first();
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return LaporanpelumasModel
	 *  @throws \Exception
	 */
	public function store($input)
	{

		$data = [
			"tahun"         => date("Y"),
			"bulan"         => date("n", strtotime($input["voyage_from"])),
			"bulan_text"    => date("F", strtotime($input["voyage_from"])),
			"voyage_id"     => $input["voyageKode"],
			"voyage_name"   => $input["voyageName"],
			"voyage_num"    => $input["voyageKode"],
			"voyage_from"   => $input["voyage_from"],
			"voyage_to"     => $input["voyage_to"],
			"keterangan"     => $input["keterangan"],
			"tipe"          => "VOYAGE",
			"is_locked"     => "N",
			"kapalId"       => $input["kapalId"]
		];

		$dock = new LaporanpelumasModel();
		$dock->fill($data);
		if (!$dock->save()) {
			throw new \Exception();
		}
		return $dock->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return LaporanpelumasModel
	 *  @throws \Exception
	 */
	public function update($ID, $input)
	{
		$pelumas = LaporanpelumasModel::find($ID);
		$pelumas->fill(["keterangan" => $input["keterangan"]]);
		if (!$pelumas->update()) {
			throw new \Exception();
		}

		if (isset($input["pelabuhan"])) {
			foreach ($input["pelabuhan"] as $itemDetailID => $pelabuhan) {
				$pelumas = LaporanpelumasitemdetailsModel::find($itemDetailID);
				$pelumas->fill(["pelabuhan" => $pelabuhan]);
				if (!$pelumas->update()) {
					throw new \Exception();
				}
			}
		}

		return $pelumas;
	}

	//update is_locked
	public function isLocked($id, $isLocked)
	{
		$pelumas = LaporanpelumasModel::find($id);
		$pelumas->fill(["is_locked" => $isLocked]);
		if (!$pelumas->update()) {
			throw new \Exception();
		}
		return $pelumas;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function repopulateData($laporan)
	{
		$this->detailService->repopulateData($laporan);
	}

	public function repopulateDataMonth($laporan)
	{
		$this->detailService->repopulateDataMonth($laporan);
	}

	public function getDataReport($tahun, $tipe = "MONTH")
	{
		$sysParams = (new SystemparameterModel())->getQuery()->where("variableName", "=", "PELNIBBMPELUMAS")->first();
		$categoryPelumas = explode(";", $sysParams->variableValue)[1];
		// $pelumasItems = (new ItemModel())->getQuery()->where("type_id", "=", $categoryPelumas)->get();

		$laporans = $this->model->getQuery()
			->where("laporanpelumas.tahun", "=", $tahun)
			->where("laporanpelumas.tipe", "=", $tipe)
			->orderBy("laporanpelumas.voyage_from", "ASC")
			->orderBy("laporanpelumas.voyage_to", "ASC")
			->get();

		$nPenerimaan = $rowLaporans = $headerItems = [];
		foreach ($laporans as $laporan) {
			$rowLaporan = [];
			// foreach ($pelumasItems as $pelumasItem) {

			$rowLaporan["keterangan"] = $laporan->keterangan;
			$rowLaporan["awal"] = date("d M Y", strtotime($laporan->voyage_from));
			$rowLaporan["akhir"] = date("d M Y", strtotime($laporan->voyage_to));
			$rowLaporan["bulan"] = $laporan->bulan_text;
			$idxLaporan = $rowLaporan["idxLaporan"] = $laporan->id;

			if ($tipe == "MONTH") {
				$details = $this->detailService->showByMonth($laporan->id);
			} else {
				if ($laporan->voyage_num > 0) {
					$rowLaporan["bulan"] = "Voyage " . $laporan->voyage_num;
				} else {
					$rowLaporan["bulan"] = $laporan->voyage_name;
				}
				$details = $this->detailService->showByVoyageVer2($laporan->id);
			}

			foreach ($details as $detail) {
				if (!empty($detail->transactionDate)) {
					$detail->transactionDate = date("Y-m-d", strtotime($detail->transactionDate));
					if (!isset($nPenerimaan[$idxLaporan]["transactionDate"][$detail->transactionDate])) {
						$nPenerimaan[$idxLaporan]["transactionDate"][$detail->transactionDate] = $detail->pelabuhan;
					}
				}

				$rowLaporan[$detail->itemId][$idxLaporan]["saldo_awal"] = $detail->saldo_awal;
				$rowLaporan[$detail->itemId][$idxLaporan]["pemakaian"] = $detail->pemakaian;
				$rowLaporan[$detail->itemId][$idxLaporan]["saldo_akhir"] = $detail->saldo_akhir;
				$rowLaporan[$detail->itemId][$idxLaporan]["namaItem"] = $detail->namaItem;
				$rowLaporan[$detail->itemId][$idxLaporan]["deskripsi"] = $detail->deskripsi;
				if (!isset($rowLaporan[$detail->itemId][$idxLaporan]["penerimaan"][$detail->transactionDate]["qty"])) {
					$rowLaporan[$detail->itemId][$idxLaporan]["penerimaan"][$detail->transactionDate]["qty"] = $detail->qty;
				} else {
					$rowLaporan[$detail->itemId][$idxLaporan]["penerimaan"][$detail->transactionDate]["qty"] += $detail->qty;
				}

				if ($detail->saldo_awal > 0 || $detail->qty) {
					if (!isset($headerItems[$detail->itemId]["deskripsi"])) {
						$headerItems[$detail->itemId]["deskripsi"] = $detail->deskripsi;
					}
					$headerItems[$detail->itemId]["isEmpty"] = "N";
				}
			}
			// }

			$rowLaporans[] = $rowLaporan;
		}
		return ["rowLaporans" => $rowLaporans, "headerItems" => $headerItems, "nPenerimaan" => $nPenerimaan];
	}
}
